#
# Invoke as &setup_nexus_safe_signals($ED, \&terminate_func);
#

sub setup_nexus_safe_signals
{
    my($ed, $terminate_func) = @_;

    print "setup signals ed=$ed\n";
    

    $SIG{'INT'} = \&Utils::handle_sig;
    $SIG{'TERM'} = \&Utils::handle_sig;
    $SIG{'HUP'} = \&Utils::handle_sig;

    $Utils::TerminateWrite = \*{"Utils::TerminateWrite"};
    $Utils::TerminateRead = \*{"Utils::TerminateWrite"};

    pipe($Utils::TerminateRead, $Utils::TerminateWrite);
    select((select($Utils::TerminateWrite), $| = 1)[0]);
    $ed->register($Utils::TerminateRead, $terminate_func);
}

sub dump_nested
{
    my($ref, $indent) = @_;
    my $spaces = ' ' x ($indent * 2);

    if (ref($ref) eq "ARRAY")
    {
	my($l,$r);

	$l = @$ref;
	print "${spaces}Array[$l]:\n" if ($debug_level);
	for $r (@$ref)
	{
	    &dump_nested($r, $indent + 1);
	}
    }
    elsif (ref($ref) eq "HASH")
    {
	my($k, $v);

	print "${spaces}Hash:\n" if ($debug_level);
	while (($k, $v) = each(%$ref))
	{
	    print "${spaces}Key=\"$k\"\n" if ($debug_level);
	    &dump_nested($v, $indent + 1);
	}
    }
    else
    {
	print "${spaces}Other: $ref\n" if ($debug_level);
    }
}

sub Utils::handle_sig
{
    my($s) = @_;

    print "Got signal $s $Utils::TerminateWrite\n";
    print $Utils::TerminateWrite "Hey there!\n";
}

#
# Grok a mcp list. Return a hash that is the alist if it is one, undef
# otherwise.
sub grok_alist
{
    my($alist) = @_;
    my($aelt, $hash, $r);

    if (ref($alist) ne 'ARRAY')
    {
	return undef;
    }

    $hash = {};

    for $aelt (@$alist)
    {
	$r = ref($aelt);
	if ($r ne 'ARRAY')
	{
	    #
	    # This is really bizarre.
	    #
	    # So bizarre that I claim it's a perl bug.
	    #
	    # The following line is required to make the above test
	    # succeed.
	    #
	    my $a = "$r";
	    return undef;
	}
	print "1\n";
	return undef if @$aelt != 2;
	$hash->{$aelt->[0]} = $aelt->[1];
    }
    return $hash;
}
    

1;