#ifndef STEX_H
#define STEX_H

/* Standard include stuff */
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#define _BSD_SIGNALS
#include <signal.h>

/* Platform specific stuff: SGI */
#include <malloc.h>
#include <bstring.h>
#include <cave.h>
#include <gl.h>
#include <gl/device.h>

/* Nexus */
#include <nexuslite.h>

/* Defines */
#define MAXPAN      3000
#define MAXTILT     500
#define NUMNAMES    10
#define MAXNAME     100

#ifdef __cplusplus
extern "C" {
#endif

/* Prototypes */
void update_pan_tilt(float azi, float elev, nexus_global_pointer_t *gp);

extern char *nexus_global_pointer_string(nexus_global_pointer_t *global_pointer);

extern void ptto(int pp, int tp, nexus_global_pointer_t *gp);

extern void reset_robot(nexus_global_pointer_t *gp, char *name);
extern void update_robot(float x, float y, float maxx, float maxy,
		  nexus_global_pointer_t *gp, char *name);
extern void turn_robot(int degs, nexus_global_pointer_t *gp, char *name);
extern void move_robot(int z, int direction, nexus_global_pointer_t *gp, char *name);
extern void beep_robot(nexus_global_pointer_t *gp, char *name);

extern void set_mono(nexus_global_pointer_t *gp, int *val);
extern void set_stereo(nexus_global_pointer_t *gp, int *val);

extern void zoom_in(nexus_global_pointer_t *gp);
extern void zoom_out(nexus_global_pointer_t *gp);
extern void focus_near(nexus_global_pointer_t *gp);
extern void focus_far(nexus_global_pointer_t *gp);

extern void set_control(nexus_global_pointer_t *gp, int val);
extern void set_mode(nexus_global_pointer_t *gp, int *val);
extern void set_activity(nexus_global_pointer_t *gp, int *val);
extern void set_exit(nexus_global_pointer_t *gp);

extern void sync_control(void *address, nexus_buffer_t *buffer);
extern void sync_mode(void *address, nexus_buffer_t *buffer);
extern void sync_activity(void *address, nexus_buffer_t *buffer);
extern void sync_exit(void *address, nexus_buffer_t *buffer);
extern void get_ack(void *address, nexus_buffer_t *buffer);

extern void register_module(nexus_global_pointer_t *to_gp, char *name);
extern void unregister_module(nexus_global_pointer_t *to_gp, char *name);

extern void update_modules(void *address, nexus_buffer_t *buffer);

extern void add_dest(int port, nexus_global_pointer_t *gp);

#ifdef __cplusplus
}
#endif

#endif

