#ifndef _net_receiver_h
#define _net_receiver_h

#include "net.h"
#include "packet.h"

#define BUFSIZE 2048

class NetReceiver
{
 public:
    NetReceiver(Network *net);

    Network *network() { return network_; };

    void run();

 protected:
    int maxbw_;
    double bw_;
    double rtcp_inv_bw_;

    char buf_[BUFSIZE];
    
    Network *network_;

    virtual void receive_rtp();
    virtual void receive_rtcp();

    virtual void process_rtp(rtphdr *header, u_char *data, int data_len);
    virtual void process_rtcp(rtcphdr *header, u_char *data, int data_len);
    
};
#endif /* net_receiver_h */
