#include <stdlib.h>
#include <unistd.h>
#include <osfcn.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <sys/time.h>
#include <sys/uio.h>
#include <sys/types.h>

#include "net.h"
#include "mcastchan.h"
#include "inet.h"
#include "packet.h"
#include "reasm-jpeg.h"

#include "JpegReceiver.h"

#ifdef _AIX
#include <sys/select.h>
#endif

void sighandle(void)
{
    exit(0);
}


main(int argc, char **argv)
{
    char *host;
    n_long addr;
    unsigned char *addrC;
    u_short port;
    int ttl;
    int ctrlsock = 1;
    Network *net;
    JpegReceiver *receiver;
    myim Image;
	
    Image.data = (unsigned char *)malloc(640*480*4);	
    Image.lock = 0;

    if (argc != 3)
    {
	printf("Usage: %s address port \n", argv[0]);
	exit(1);
    }

    host = argv[1];
    port = atoi(argv[2]);
    
    addr = LookupHostAddr(host);
    ttl = 4;

    addrC = (unsigned char *) &addr;
    printf("Connecting to %d.%d.%d.%d/%d\n",
	   addrC[0], addrC[1], addrC[2], addrC[3], port);
    net = new mcastChannel(addr, port, ttl, ctrlsock);

    receiver = new JpegReceiver(net, &Image);

    signal(SIGHUP, sighandle);
    signal(SIGKILL, sighandle);
    receiver->run();

    return 0;
}
